'MMEDIT!!! Basic Version = Micromite_Plus_V5.3#
'MMEDIT!!! Port = 10.0.0.204:23:30,150
'MMEDIT!!! Device = ESPBasic
'MMEDIT!!! Config = 100111100121010111101011010011
  '------------------------------------------------------------------------------'
  '       This code demonstrates the use of the simpleArrayFuncGen.exe           '
  '       written by @Nathan from The Backshed Forum (TBS).                      '
  '       Details and code are in this forum post.                               ' 
  '       http://www.thebackshed.com/forum/forum_posts.asp?TID=10253&PN=7        '
  '                                                                              '
  '       Additional Directives that allow the config files for the              '  
  '       simpleArrayFuncGen to be defined within the MMEDIT code window         '
  '       and the automated execution of simpleArrayGenerator  are provided      '
  '       by the MMReplace.exe utility which is called by MMEdit.                '
  '                                                                              '
  '       Author:   Disco4now TBS Forum                                          '
  '                                                                              '
  dim ProgTitle$ = "simpleArrayFuncGen Test Suite"                               '
  '                                                                              '
  Dim ProgVer$   = "v1.0.0"                                                      '
  '                                                                              '
  Dim ProgDate$  = "12-Apr-2018"                                                 '
  '------------------------------------------------------------------------------'
 '  Directives:
 '  #ARRAYGENERATE       - Causes the defined arrays to be generated
 '  #ARRAYSTART [string|integer|float] [cfunction|csub] functionorsubname  - Start of array  
 '  : string1            - each element entry start a colon plus a space
 '  #ARRAYEND            - End of array
 '  #ARRAYINCLUDE functionorsubname  - Includes the file containg the specified CSUB/CFUNCTION
'================================================================================================ 
'MEMORY SUMMARY simpleArrayFuncGen vs Tradional DATA and READ for array of 900 integers
'----------------------------------------------------------------------------------------
'  simpleArrayGeneration CFUNCTION   Traditional DATA and READ method
' -------------------------------    ---------------------------------         
'Flash:                              Flash: 
'   1K ( 1%) Program (24 lines)        3K ( 3%) Program (51 lines)
'   4K ( 4%) Library                    
'  95K (95%) Free                     97K (97%) Free
'
'RAM:                                RAM:
'   1K ( 1%) 8 Variables                9K ( 8%) 9 Variables
'   0K ( 0%) General                    0K ( 0%) General 
' 102K (99%) Free                      94K (92%) Free
'
'Array is stored in CFUNCTION        No CFUNCTION but code for DATA statements
'takes 4K but reduces code size      uses 2K of flash.
'in flash by 2K.So net 2K extra.
'Array is not in RAM so 8K of        Array is in RAM and takes 8K
'RAM saved.
'
'================================================================================================ 
   'Uncomment to load library  
'#LIBRARYLOAD
  Option Explicit
  Option Default NONE
  
   'Set up some variables
  dim integer i,j,k%,l%,m%
  
  
  ? "**************** Printing arrays and strings stored as CFUNCTION code"
  
   'Code to printout the Integer Array (CFunction Version)
  ? "..........Integer Array from CFUNCTION .............."
  k%=myIntArray()    'get number of arrays
   ? k%
  for i=0 to k%-1
    l%=myIntArray(i) 'get number of elements  
    ? l%," array begin -> "
    for j=0 to l%-1
     m%=myIntArray(i,j)
     if (j+1) mod 30 = 0 then
      ? m%
     else 
      ? m%;
     endif  
     next j 
     ?
  next i
  
  memory
  '================================================================================================
  ' Setup Directives and data for arrays
  ' The lines between #ARRAYSTART and #ARRAYEND become the -cfg file for simpleArrayGenerator
  ' The parameters on #ARRAYSTART are used to generate the correct commandline parameters
  ' for simpleArrayGenerator.
  ' The ARRAYGENERATE can be commented once the CSUB/CFUNCTION is generated if the data is not changed.
  ' It can be left in so they generate fresh for each load if there is little performance impact.
  ' #ARRAYINCLUDE myStrArrayFunct   - Include the file generated by simpleArrayGenerator.exe for
  ' the specified function/sub at the specified location.
  '================================================================================================ 
#ARRAYGENERATE
' Array of 900 as lookup
#ARRAYSTART int cfunction myIntArray
: 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 900
#ARRAYEND



#LIBRARYSTART

#ARRAYINCLUDE myIntArray

#LIBRARYEND


 
