'MMEDIT!!! Basic Version = Micromite_Plus_V5.3#
'MMEDIT!!! Port = 10.0.0.204:23:30,150
'MMEDIT!!! Device = Micromite_Plus_V5.3#
'MMEDIT!!! Config = 100111100121010111101011010011
  '------------------------------------------------------------------------------'
  '       This code demonstrates the use of DATA and READ statements to          '
  '       load an array of 900 integers so memory usage can be compared          '
  '       with the use of simpleArrayFuncGen by @Nathan  of TBS forum            ' 
  
  '       Author:   Disco4now TBS Forum                                          '
  '                                                                              '
  dim ProgTitle$ = "Array load by DATA and READ statements Test Suite"           '
  '                                                                              '
  Dim ProgVer$   = "v1.0.0"                                                      '
  '                                                                              '
  Dim ProgDate$  = "12-Apr-2018"                                                 '
  '------------------------------------------------------------------------------'
 '  Directives:
 '  #ARRAYGENERATE       - Causes the defined arrays to be generated
 '  #ARRAYSTART [string|integer|float] [cfunction|csub] functionorsubname  - Start of array  
 '  : string1            - each element entry start a colon plus a space
 '  #ARRAYEND            - End of array
 '  #ARRAYINCLUDE functionorsubname  - Includes the file containg the specified CSUB/CFUNCTION
'================================================================================================ 
'MEMORY SUMMARY simpleArrayGenerator vs  Tradional DATA and READ for array of 900 integers
'  simpleArrayGeneration CFUNCTION   Traditional DATA and READ method
' -------------------------------    ---------------------------------         
'Flash:                              Flash: 
'   1K ( 1%) Program (24 lines)        3K ( 3%) Program (51 lines)
'   4K ( 4%) Library                    
'  95K (95%) Free                     97K (97%) Free
'
'RAM:                                RAM:
'   1K ( 1%) 8 Variables                9K ( 8%) 9 Variables
'   0K ( 0%) General                    0K ( 0%) General 
' 102K (99%) Free                      94K (92%) Free
'
'Array is stored in CFUNCTION        No CFUNCTION but code for DATA statements
'takes 4K but reduces code size      uses 2K of flash.
'in flash by 2K.So net 2K extra.
'Array is not in RAM so 8K of        Array is in RAM and takes 8K
'RAM saved.
'
'================================================================================================ 


  Option Explicit
  Option Default NONE
  
   'Set up some variables
  dim integer i,j,k%,l%,m%
  dim INTEGER myIntArray(900) 
  
 

' Array of 900 as lookup

DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
DATA 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60
DATA 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,900

 ? "**************** Printing array data"
  
  
  
  for i=0 to 899
    read myIntArray(i)
  next i
    
   'Code to printout the Integer Array 
  ? " array begin -> "
  for i=0 to 899
     m%=myIntArray(i)
     if (i+1) mod 30 = 0 then
      ? m%
     else 
      ? m%;
     endif  
  next i 
   
  memory
 
